marmalade-upload
================

[![Available on Hackage][badge-hackage]][hackage]
[![License MIT][badge-license]][license]
[![Build Status][badge-travis]][travis]

Haskell tool to upload packages to the Emacs package archive [Marmalade][],
published in the hopes

- that you find it useful,
- and that Marmalade dies rather sooner than later nonetheless.

I'm sorry for the inconvenient language, but if I'm to write a boring tool for a
stupid bug, then at least in a cool language.

And while we're at it, I'd like to say a big thank you to [MELPA][] for building
[stable packages][] now, and bringing Marmalade a big step closer to its
passing.  Well done, folks!

[badge-travis]: https://travis-ci.org/lunaryorn/marmalade-upload.svg?branch=master
[travis]: https://travis-ci.org/lunaryorn/marmalade-upload
[badge-hackage]: https://img.shields.io/hackage/v/marmalade-upload.svg?dummy
[hackage]: https://hackage.haskell.org/package/marmalade-upload
[badge-license]: https://img.shields.io/badge/license-MIT-green.svg?dummy
[license]: https://github.com/lunaryorn/marmalade-upload/blob/master/LICENSE
[Marmalade]: http://marmalade-repo.org
[MELPA]: http://melpa.milkbox.net
[stable packages]: https://github.com/milkypostman/melpa#stable-packages

Installation
------------

### Binaries

- [OS X 10.9](https://github.com/lunaryorn/marmalade-upload/releases/download/0.7/marmalade-upload-0.7_osx-10.9.zip)
- [Linux x86_64](https://github.com/lunaryorn/marmalade-upload/releases/download/0.7/marmalade-upload-0.7_linux-x86_64.zip)

To install, `unzip` the archive, and move the contained `marmalade-upload` file
somewhere into `$PATH`, e.g. `/usr/local/bin/`.

These binaries are statically linked and to not require Haskell or any Haskell
libraries.

### Building from Source

Install [Haskell Platform][] and type the following command to install
marmalade-upload from source:

```console
$ cabal install marmalade-upload
```

Don't forget to add `~/.cabal/bin` to `$PATH`.

[Haskell Platform]: http://www.haskell.org/platform/

Usage
-----

```console
$ marmalade-upload USERNAME PACKAGE
```

Your password will be stored in the keychain of supported systems.  Currently
the keychains of KDE and OS X are supported.

License
-------

Copyright (c) 2014 Sebastian Wiesner <lunaryorn@gmail.com>

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
the Software, and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
